#include <kernel>
#include <monitor>
#include <thread>
#include <time>

#include "long_tests.h"

#ifndef PREEMPTION_RATE
#error PREEMPTION_RATE not defined in makefile
#endif

Duration default_preemption() {
	return PREEMPTION_RATE;
}

static const unsigned long N  = 500_000ul;

monitor mon_t {};

mon_t mon1, mon2, mon3;

void foo( mon_t & mutex a, mon_t & mutex b, mon_t & mutex c ) {
	KICK_WATCHDOG;
}

thread worker_t {};

void main( worker_t & this ) {
	for( unsigned long i = 0; TEST(i < N); i++ ) {
		foo( mon1, mon2, mon3 );
	}
}

extern "C" {
static worker_t * workers;
}

int main(int argc, char * argv[] ) {
	processor p;
	{
		worker_t w[7];
		workers = w;
	}
}
